# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-perl5i
Summary:	Fix as much of Perl 5 as possible in one pragma
Version:	2.13.0
Release:	2.%{__distinit}%{__distvers}
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		https://metacpan.org/release/perl5i
Source0:	http://cpan.metacpan.org/authors/id/M/MS/MSCHWERN/perl5i-v%{version}.tar.gz
Patch0:		0001-Fix-ARGV-tests-broken-with-utf8-all-0.013-or-later.patch
# Module Build
BuildRequires:	perl(lib)
BuildRequires:	perl(Module::Build) >= 0.36
# Module Runtime
BuildRequires:	perl >= 4:5.10.0
BuildRequires:	perl(CLASS) >= 1.00
BuildRequires:	perl(Capture::Tiny) >= 0.06
BuildRequires:	perl(Carp)
BuildRequires:	perl(Carp::Fix::1_25) >= 1.000000
BuildRequires:	perl(Child) >= 0.009
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(DateTime) >= 0.47
BuildRequires:	perl(DateTime::Format::Epoch) >= 0.11
BuildRequires:	perl(DateTime::TimeZone::Tzfile) >= 0.002
BuildRequires:	perl(Devel::Declare::MethodInstaller::Simple) >= 0.006009
BuildRequires:	perl(Digest::MD5) >= 2.36
BuildRequires:	perl(Digest::SHA) >= 5.45
BuildRequires:	perl(Encode)
BuildRequires:	perl(File::chdir) >= 0.1002
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(Hash::FieldHash) >= 0.06
BuildRequires:	perl(Hash::Merge::Simple) >= 0.04
BuildRequires:	perl(Hash::StoredIterator) >= 0.007
BuildRequires:	perl(IO::Handle)
BuildRequires:	perl(IPC::System::Simple) >= 1.18
BuildRequires:	perl(JSON) >= 2.17
BuildRequires:	perl(List::MoreUtils) >= 0.22
BuildRequires:	perl(Modern::Perl) >= 1.03
BuildRequires:	perl(Module::Load) >= 0.16
BuildRequires:	perl(Object::ID) >= v0.1.0
BuildRequires:	perl(Path::Tiny) >= 0.036
BuildRequires:	perl(Perl6::Caller) >= 0.100
BuildRequires:	perl(POSIX)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(Sub::Name)
BuildRequires:	perl(Taint::Util) >= 0.06
BuildRequires:	perl(Text::Wrap) >= 2009.0305
BuildRequires:	perl(Time::y2038)
BuildRequires:	perl(Try::Tiny) >= 0.02
BuildRequires:	perl(Want) >= 0.18
BuildRequires:	perl(YAML::Any) >= 0.70
BuildRequires:	perl(autobox) >= 2.70
BuildRequires:	perl(autobox::Core) >= 1.0
BuildRequires:	perl(autobox::List::Util) >= 20090629
BuildRequires:	perl(autobox::dump) >= 20090426
BuildRequires:	perl(autodie) >= 2.12
BuildRequires:	perl(autovivification) >= 0.06
BuildRequires:	perl(base)
BuildRequires:	perl(constant)
BuildRequires:	perl(if)
BuildRequires:	perl(indirect) >= 0.24
BuildRequires:	perl(mro)
BuildRequires:	perl(open)
BuildRequires:	perl(overload)
BuildRequires:	perl(parent) >= 0.221
BuildRequires:	perl(true::VERSION) >= 0.16
BuildRequires:	perl(utf8::all) >= 0.002
BuildRequires:	perl(version) >= 0.77
# Test Suite
BuildRequires:	perl(Config)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(ExtUtils::CBuilder) >= 0.26
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(IPC::Open3)
BuildRequires:	perl(PerlIO)
BuildRequires:	perl(Test::More) >= 0.88
BuildRequires:	perl(Test::Most)
BuildRequires:	perl(Test::Output) >= 0.16
BuildRequires:	perl(Test::Warn) >= 0.11
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(CLASS) >= 1.00
Requires:	perl(Capture::Tiny) >= 0.06
Requires:	perl(Carp::Fix::1_25) >= 1.000000
Requires:	perl(Child) >= 0.009
Requires:	perl(Data::Dumper)
Requires:	perl(DateTime) >= 0.47
Requires:	perl(DateTime::Format::Epoch) >= 0.11
Requires:	perl(DateTime::TimeZone::Tzfile) >= 0.002
Requires:	perl(Devel::Declare::MethodInstaller::Simple) >= 0.006009
Requires:	perl(Digest::MD5) >= 2.36
Requires:	perl(Digest::SHA) >= 5.45
Requires:	perl(File::chdir) >= 0.1002
Requires:	perl(File::Spec)
Requires:	perl(Hash::FieldHash) >= 0.06
Requires:	perl(Hash::Merge::Simple) >= 0.04
Requires:	perl(Hash::StoredIterator) >= 0.007
Requires:	perl(IPC::System::Simple) >= 1.18
Requires:	perl(JSON) >= 2.17
Requires:	perl(List::MoreUtils) >= 0.22
Requires:	perl(Modern::Perl) >= 1.03
Requires:	perl(Module::Load) >= 0.16
Requires:	perl(Object::ID) >= v0.1.0
Requires:	perl(Path::Tiny) >= 0.036
Requires:	perl(Perl6::Caller) >= 0.100
Requires:	perl(Taint::Util) >= 0.06
Requires:	perl(Text::Wrap) >= 2009.0305
Requires:	perl(Try::Tiny) >= 0.02
Requires:	perl(Want) >= 0.18
Requires:	perl(YAML::Any) >= 0.70
Requires:	perl(autobox) >= 2.70
Requires:	perl(autobox::Core) >= 1.0
Requires:	perl(autobox::List::Util) >= 20090629
Requires:	perl(autobox::dump) >= 20090426
Requires:	perl(autodie) >= 2.12
Requires:	perl(autovivification) >= 0.06
Requires:	perl(if)
Requires:	perl(indirect) >= 0.24
Requires:	perl(parent) >= 0.221
Requires:	perl(true::VERSION) >= 0.16
Requires:	perl(utf8::all) >= 0.002

# Filter underspecified dependencies
%global __requires_exclude ^perl\\(CLASS\\)$
%global __requires_exclude %__requires_exclude|^perl\\(Carp::Fix::1_25\\)$
%global __requires_exclude %__requires_exclude|^perl\\(Hash::FieldHash\\)$
%global __requires_exclude %__requires_exclude|^perl\\(Hash::StoredIterator\\)$
%global __requires_exclude %__requires_exclude|^perl\\(Module::Load\\)$
%global __requires_exclude %__requires_exclude|^perl\\(Try::Tiny\\)$
%global __requires_exclude %__requires_exclude|^perl\\(Want\\)$
%global __requires_exclude %__requires_exclude|^perl\\(autobox\\)$
%global __requires_exclude %__requires_exclude|^perl\\(autobox::Core\\)$
%global __requires_exclude %__requires_exclude|^perl\\(autobox::List::Util\\)$
%global __requires_exclude %__requires_exclude|^perl\\(autobox::dump\\)$
%global __requires_exclude %__requires_exclude|^perl\\(autodie\\)$
%global __requires_exclude %__requires_exclude|^perl\\(autovivification\\)$
%global __requires_exclude %__requires_exclude|^perl\\(parent\\)$

%description
Perl 5 has a lot of warts. There's a lot of individual modules and techniques
out there to fix those warts. perl5i aims to pull the best of them together
into one module so you can turn them on all at once.
 
This includes adding features, changing existing core functions and changing
defaults. It will likely not be 100%% backwards compatible with Perl 5, though
it will be 99%%, perl5i will try to have a lexical effect.
 
Please add to this imaginary world and help make it real, either by telling
me what Perl looks like in your imagination
(http://github.com/schwern/perl5i/issues) or make a fork (forking on github is
like a branch you control) and implement it yourself.

%prep
%setup -q -n perl5i-v%{version}

# Upstream fix for compatibility with utf8::all ≳ 0.013
# https://github.com/evalEmpire/perl5i/pull/280
%patch0 -p1

%build
perl Build.PL --installdirs=vendor --optimize="%{optflags}"
./Build

%install
./Build install --destdir=%{buildroot} --create_packlist=0
%{_fixperms} %{buildroot}

%check
./Build test

%files
%license LICENSE
%doc Changes README
%{_bindir}/perl5i
%{perl_vendorlib}/perl5i.pm
%{perl_vendorlib}/perl5i/
%doc %{perl_vendorlib}/perl5ifaq.pod
%{_mandir}/man3/perl5i.3pm*
%{_mandir}/man3/perl5i::Meta.3pm*
%{_mandir}/man3/perl5i::Signature.3pm*
%{_mandir}/man3/perl5i::latest.3pm*
%{_mandir}/man3/perl5ifaq.3pm*

%changelog
* Tue Sep  9 2014 Paul Howarth <paul@city-fan.org> - 2.13.0-2
- Add upstream fix for compatibility with utf8::all ≳ 0.013 (#1134872)

* Thu Jul 24 2014 Paul Howarth <paul@city-fan.org> - 2.13.0-1
- Update to 2.13.0
  - $scalar->path will return a Path::Tiny object using the contents of
    $scalar, which makes working with files much, much easier (GH#229, GH#247)
  - The project has moved to the evalEmpire organization to allow broader
    project admin options (http://github.com/evalEmpire/perl5i)
  - Added a project rationale (GH#226, GH#252)
  - Fixed a crash if the perl5i command line is fed a null byte
    (GH#269, GH#273)
  - Stop using deprecated Hash::StoreIterator::eech() (GH#270)
  - The methods() meta method now ignores subroutines declared with func()
    (GH#222, GH#253)
- Use %%license

* Thu Sep 12 2013 Paul Howarth <paul@city-fan.org> - 2.12.0-3
- Add missing dependencies (#998496)
  - BR: perl(lib) for the build process
  - BR: perl(Carp), perl(Data::Dumper), perl(Encode), perl(File::Spec),
    perl(if), perl(IO::Handle), perl(POSIX), perl(Scalar::Util) and
    perl(Sub::Name) for the module
  - BR: perl(Config), perl(Exporter), (File::Temp) and perl(PerlIO) for the
    test suite
  - R: perl(Data::Dumper), perl(File::Spec) and perl(if) for runtime

* Fri Aug 16 2013 Paul Howarth <paul@city-fan.org> - 2.12.0-1
- Initial RPM version
